--Taser script for CS2D
--by Avobolt (#USGN 88318)
 
Array = function(m, v)	--returns table with m indexes with v as value
	if not v then v = 0 end
	local t = {}
	for i = 1, m do
		t[i] = v
	end
	return t
end
 
Distance = function(id, ID)
	return math.sqrt((player(id, "x")-player(ID, "x"))^2 + (player(id, "y")-player(ID, "y"))^2)
end 

ResetArray = function()
	local t = {}
	for i=1, 32 do
		local T = {false, false}
		t[i] = T
	end
	return t
end

--Configuration

Taser = ResetArray()
TaserImage = Array(32, -1)

TaserName = "Zeus x27"
TaserRange = 64
TaserAttackSound = "weapons/taser_attack.ogg"
TaserDrawSound = "weapons/taser_draw.ogg"

TaserInHandImage = "gfx/weapons/taser.bmp"
TaserKillImage = "gfx/weapons/taser_k.bmp"

TaserAngle = 30
TaserSoundRange = 160
TaserBaseDamage = 500
TaserPrice = 200

-- functions

addhook("attack", "HookAttack")
HookAttack = function(id)
	local target = {0, math.huge, math.huge}
	
	if player(id, "weapon") == 50 and Taser[id][1] and Taser[id][2] then
		Taser[id][1] = false 
		Taser[id][2] = false 
		freeimage(TaserImage[id])
		TaserImage[id] = -1

		for _, ID in pairs(player(0, "tableliving")) do
			local d = Distance(id, ID)
			if d <= TaserSoundRange then
				parse('sv_sound2 '..ID..' " '..TaserAttackSound..'"')
			end
			
			if ID~=id and (game("sv_friendlyfire") == "1" or player(id, "team")~=player(ID, "team")) then
				local idx, idy, IDx, IDy = player(id, "x"), player(id, "y"), player(ID, "x"), player(ID, "y")
				local ang = math.deg(math.atan2(idy-IDy, idx-IDx) - math.pi/2) % 360
				local rot = player(id,"rot") % 360
				local diff = math.abs(ang-rot)
				
				if d <= TaserRange and diff <= TaserAngle then
					if diff <= target[2] and d < target[3] then
						target[1] = ID
						target[2] = diff
						target[3] = d
					end	
				end
			end
			
			
		end
	
		if target[1] ~= 0 then
			local hp = player(target[1], "health") - TaserBaseDamage * (1 - target[3]/TaserRange)
			if hp <= 0 then
				parse('customkill '..id..' "'..TaserName..','..TaserKillImage..'" '..target[1])
			else
				parse("sethealth "..target[1].." "..hp)
			end
		end
	
		
	
	end
end

addhook("die", "HookDie")
HookDie = function(id)
	Taser[id][1] = false
	Taser[id][2] = false
end

addhook("ms100", "HookMs100")
HookMs100 = function()
	for _, id in pairs(player(0, "tableliving")) do
		
		
		if player(id, "weapon") == 50 and Taser[id][2]  then
			if  TaserImage[id] == -1 then
				TaserImage[id] = image(TaserInHandImage.."<m>", 1, 0, id + 200)
				parse('sv_sound2 '..id..' " '..TaserDrawSound..'"')
			end
		else
			if TaserImage[id] ~= -1 then
				freeimage(TaserImage[id])
				TaserImage[id] = -1
			end
			Taser[id][2] = false
			
		end
	
	end
end

addhook("startround_prespawn", "HookStartround")
HookStartround = function()
	TaserImage = Array(32, -1)
end

addhook("serveraction", "HookServeraction")
HookServeraction = function(id, act)
	if act == 2 then
		if inentityzone(player(id, "tilex"), player(id, "tiley"), 0) or  inentityzone(player(id, "tilex"), player(id, "tiley"), 1) then
			menu(id, "Buy a taser,"..TaserName.."|$"..TaserPrice)
		else
			msg2(id, "\169255000000You are not in a buyzone!")
		end
	elseif act == 3 then
	parse("setweapon "..id.." 50")
		if Taser[id][1] then
				Taser[id][2] = not Taser[id][2] 
			end
	end
end

addhook("menu", "HookMenu")
HookMenu = function(id, title, b)
	if title == "Buy a taser" and b == 1 then
		if Taser[id][1]  == false then
			if player(id, "money") >= TaserPrice then
				parse("setmoney "..id.. " "..(player(id, "money")-TaserPrice))
				Taser[id][1] = true
				msg2(id, "\169000255000You bought a taser! F4 to choose it/switch to knife!")
			else
				msg2(id, "\169255000000You have insufficient funds!")
			end
		else
			msg2(id, "\169255000000You can't carry more!")
		end
	end
end

print("Taser script loaded!")